#include "new_class_id.h"
#include "new_object_list.h"
#include <iostream>

#include <base_object.h>

class NewBaseObject
{
public:
  void setName(const std::string& name) { this->_objectName = name; };
  const std::string& getName() const { return _objectName; };
  bool operator==(const std::string& name) const { return _objectName == name; };

  NewObjectListDeclaration(NewBaseObject);

protected:
  NewBaseObject(const std::string& objectName = "") : _objectName(objectName)
  {
    this->registerObject(this, objectList);
  };
  template<class T>
  inline void registerObject(T* object, NewObjectList<T>& objectList) { _id.registerObject(object, objectList); };
private:
  NewClassID    _id;
  std::string   _objectName;


};
NewObjectListDefinition(NewBaseObject);


class Test : public NewBaseObject
{
public:
  Test();
  ~Test();


  NewObjectListDeclaration(Test);
  //ObjectListDeclaration(Test);
};
NewObjectListDefinition(Test);

Test::Test()
{
//  this->setClassID(CL_PARENT_NODE, "Test");
  this->registerObject(this, Test::objectList);
  // std::cout << "Test()\n";
};
Test::~Test()
{
  //  std::cout << "~Test()\n";
}

class Bone : public BaseObject
{
public:
  Bone()
  {
//    this->registerObject(this, Bone::objectList);
    //std::cout << "Bone()\n";
  };
  ~Bone()
  {
    //  std::cout << "~Bone()\n";
  };
  NewObjectListDeclaration(Bone);
};
NewObjectListDefinition(Bone);

int main()
{
  for (unsigned int i = 0; i < 20; ++i)
  {
    std::cout<< i << std::endl;
    Test* test = new Test[10000];
    delete[]test;
  }
  //   char tmp[100];
  //   for (unsigned int i = 0 ; i < 100; ++i)
  //   {
  //     sprintf(tmp, "Tmp_%d", i);
  //     test[i].setName(tmp);
  //   }
  //   Test::objectList.debug();
  //   //test->setName("Test-object");
  //
  //   std::cout << "Here is debug of all BaseObject\n";
  //   BaseObject::objectList.debug();
  // //   delete bone;
  //   delete []test;
  //   std::cout << "Again\n";
  //   BaseObject::objectList.debug();

}

